#pragma once


#include "OpenGLWnd1.h"


#define GET_EDITHANDLER(clType) clType*	lpHandler = m_lpDataHandler ? dynamic_cast< clType* >( m_lpDataHandler ) : NULL


class CToolboxBase;
class CHandleBase;


class CEditBase : public CFormView
{
public:

	CEditBase() : CFormView( IDD_EDIT_EMPTY ) { }
	CEditBase( int iId ) : CFormView( iId ) { }
	virtual ~CEditBase() { }

	DECLARE_DYNCREATE(CEditBase)

    virtual void    vSetAutomaticCamera(bool boAutomaticCamera) { }
    virtual void    vSetShowAxis(bool boShow) { }
    virtual void    vSetBkgColor(COLORREF BkgColor) { }

    virtual BOOL    boOnIdle() { return TRUE; }
    virtual void    vRelease() { }
};


class CEditGfxBase : public CEditBase
{
public:

	DECLARE_DYNAMIC(CEditGfxBase)

	CEditGfxBase();
	CEditGfxBase( int iId );
	~CEditGfxBase();

    virtual void    vSetAutomaticCamera(bool boAutomaticCamera) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAutomaticCamera(boAutomaticCamera); }
    virtual void    vSetShowAxis(bool boShow) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowAxis(boShow); }
    virtual void    vSetBkgColor(COLORREF BkgColor) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetBkgColor(BkgColor); }

	virtual void	vOnInitEdit() { }
	virtual	BOOL	boOnIdle();
	virtual void	vCheckKeys( float fFrameRate ) { }
	virtual void	vRelease();

	void	vSetDataTypeHandler( CHandleBase* lpHandler );
    void    vReloadTextures();
    void    vRedrawOpenGLWnd() { if(m_OpenGLWnd) m_OpenGLWnd->InvalidateRect(NULL,FALSE); }
	void	vSetTextToDisplay(const char* pszText) { if(m_OpenGLWnd) m_OpenGLWnd->vSetTextToDisplay(pszText); }
    void    vCreateOpenGLWnd();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditSprite)
	public:
	virtual void OnInitialUpdate();
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

protected:

	virtual CToolboxBase*	lpGetBaseToolbox() = 0;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);

	DECLARE_MESSAGE_MAP()

protected:

    CHandleBase*		m_lpDataHandler;
    COpenGLWnd*         m_OpenGLWnd;
    bool                m_OpenGLWndCreated;
};
