// EditMesh.cpp : implementation file
//

#include "stdafx.h"

#include "Resource.h"
#include "ChildFrm.h"
#include "HandleBase.h"
#include "HandleMesh.h"
#include "EditBase.h"
#include "EditMesh.h"

#include "ToolboxBase.h"
#include "ToolboxItfBase.h"
#include "ToolboxSheet.h"
#include "TlboxMeshItf.h"
#include "Toolbox2Mesh.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CEditMesh

IMPLEMENT_DYNCREATE(CEditMesh, CEditGfxBase)

CEditMesh::CEditMesh() : CEditGfxBase(CEditMesh::IDD)
{
	//{{AFX_DATA_INIT(CEditMesh)
	//}}AFX_DATA_INIT
}


BEGIN_MESSAGE_MAP(CEditMesh, CEditGfxBase)
	//{{AFX_MSG_MAP(CEditMesh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditMesh message handlers

void CEditMesh::vOnInitEdit()
{
	GET_EDITHANDLER(CHandleMesh);

    DWORD dwNumMesh;

    CTrLstMsh* lpTrMsh = lpHandler->GetMesh( dwNumMesh );

	sGfxDisplay	LstGfx[ 1 ];

	LstGfx[ 0 ] = sGfxDisplay( true, lpHandler->boIsStaticMesh() ? TrObj_Type_StaticMesh : TrObj_Type_Mesh, lpTrMsh, NULL );

    m_OpenGLWnd->vSetGfxAddr( LstGfx, 1, false, dwNumMesh );

    if (!lpGetToolbox()->vSetHandlers(lpHandler,this))
	{
		lpGetToolbox()->vSetHandlers(lpHandler,this);
	}

    InvalidateRect(NULL);
}


CToolboxBase*	CEditMesh::lpGetBaseToolbox()
{
	return GET_TOOLBOX(CToolbox2Mesh);
}


CToolbox2Mesh*	CEditMesh::lpGetToolbox()
{
	return GET_TOOLBOX(CToolbox2Mesh);
}


void CEditMesh::vCheckKeys(float fFrameRate)
{
	GET_EDITHANDLER(CHandleMesh);

    bool boShifted  = GetAsyncKeyState(VK_SHIFT)   & 0x8001 ? true : false;
    bool boCtrled   = GetAsyncKeyState(VK_CONTROL) & 0x8001 ? true : false;

    if(fFrameRate == 0.0f) fFrameRate = 1.0f;

    bit16 sStep = (bit16)(70.0f / fFrameRate); if(!sStep) sStep = 1;

    DWORD   dwNumMesh;

    CTrLstMsh*  lpMsh       = lpHandler ? lpHandler->GetMesh(dwNumMesh) : NULL;
    bool        boStatMesh  = lpHandler ? lpHandler->boIsStaticMesh() : false;

    bit16 sIts  = GetAsyncKeyState(VK_SUBTRACT) & 0x8001 ? -1 : GetAsyncKeyState(VK_ADD) & 0x8001 ? +1 : 0;

    if(sIts)
        {
        m_OpenGLWnd->vModifyIntensOfSelectedVertices(sIts * 50 * sStep);
        lpHandler->vSetChanged();
        }

    if(!lpMsh  ||  (!boShifted  &&  !boCtrled)) return;

    bit16 sXSgn = GetAsyncKeyState(VK_LEFT)  & 0x8001 ? -1 : GetAsyncKeyState(VK_RIGHT) & 0x8001 ? +1 : 0;
    bit16 sYSgn = GetAsyncKeyState(VK_PRIOR) & 0x8001 ? -1 : GetAsyncKeyState(VK_NEXT)  & 0x8001 ? +1 : 0;
    bit16 sZSgn = GetAsyncKeyState(VK_DOWN)  & 0x8001 ? -1 : GetAsyncKeyState(VK_UP)    & 0x8001 ? +1 : 0;
    
    if(!sXSgn  &&  !sYSgn  &&  !sZSgn) return;

    if(boShifted)
        {
        TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

        CTRFile::vTranslateMesh(lpMesh,sStep * sXSgn,sStep * sYSgn,sStep * sZSgn,true,lpHandler->lpGetTRFile());
        }

    if(boCtrled)
        {
        if(boStatMesh  &&  lpGetToolbox())
            {
            CTrStatMsh* lpStatMesh = static_cast<CTrStatMsh*>(lpMsh);

            CVect3D vecTrans((float)(sStep * sXSgn), (float)(-sStep * sYSgn), (float)(-sStep * sZSgn));

            BOOL boBB1IsSel = lpGetToolbox()->boStaticBB1IsSel();
            BOOL boBB2IsSel = lpGetToolbox()->boStaticBB2IsSel();

            if(boBB1IsSel)
                {
                CBoundingBox& BB = lpStatMesh->GetBBVisibility();

                BB.vSetBB(BB.GetBBLo() + vecTrans,BB.GetBBHi() + vecTrans);
                }

            if(boBB2IsSel)
                {
                CBoundingBox& BB = lpStatMesh->GetBBCollision();

                BB.vSetBB(BB.GetBBLo() + vecTrans,BB.GetBBHi() + vecTrans);
                }
            }
        else
            {
            TR123_MESH* lpMesh = const_cast<TR123_MESH*>(lpMsh->lpGetMesh(dwNumMesh));

            lpMesh->Center.sX += sStep * sXSgn;
            lpMesh->Center.sY += sStep * sYSgn;
            lpMesh->Center.sZ += sStep * sZSgn;
            }
        }

    lpHandler->vSetChanged();
}


