// EditSounds.cpp : implementation file
//

#include "stdafx.h"

#include "Resource.h"
#include "TrViewer.h"
#include "ChildFrm.h"
#include "FileTree.h"
#include "HandleBase.h"
#include "HandleSounds.h"
#include "EditBase.h"
#include "EditSounds.h"

#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditSounds

IMPLEMENT_DYNCREATE(CEditSounds, CFormView)

CEditSounds::CEditSounds()
	: CEditBase(CEditSounds::IDD)
{
	//{{AFX_DATA_INIT(CEditSounds)
	m_dwNumSounds = 0;
	m_dwNumUsedSounds = 0;
	m_dwNumSamples = 0;
	m_dwPriority = 0;
	m_lRange = 0;
	m_dwChannel = 0;
	m_lVolume = 0;
	m_dwFirstIndex = 0;
	m_dwInternalIndex = 0;
	//}}AFX_DATA_INIT
    m_lpDataHandler     = NULL;
}

CEditSounds::~CEditSounds()
{
    vRelease();
}

void CEditSounds::vRelease()
{
    m_lpDataHandler = NULL;
}

void CEditSounds::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditSounds)
	DDX_Control(pDX, IDC_COMBO_SOUNDMAPPING, m_ComboSoundMapping);
	DDX_Control(pDX, IDC_USEDSOUNDS, m_UsedSoundList);
	DDX_Control(pDX, IDC_SOUNDLIST, m_SoundList);
	DDX_Text(pDX, IDC_NUMSOUNDS, m_dwNumSounds);
	DDX_Text(pDX, IDC_NUMUSEDSOUNDS, m_dwNumUsedSounds);
	DDX_Text(pDX, IDC_SOUND_NUMSAMPLES, m_dwNumSamples);
	DDV_MinMaxDWord(pDX, m_dwNumSamples, 1, 63);
	DDX_Text(pDX, IDC_SOUND_PRIORITY, m_dwPriority);
	DDV_MinMaxDWord(pDX, m_dwPriority, 0, 255);
	DDX_Text(pDX, IDC_SOUND_RANGE, m_lRange);
	DDX_Text(pDX, IDC_SOUND_CHANNEL, m_dwChannel);
	DDV_MinMaxDWord(pDX, m_dwChannel, 0, 3);
	DDX_Text(pDX, IDC_SOUND_VOLUME, m_lVolume);
	DDX_Text(pDX, IDC_FIRSTINDEX, m_dwFirstIndex);
	DDX_Text(pDX, IDC_INTERNALINDEX, m_dwInternalIndex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditSounds, CFormView)
	//{{AFX_MSG_MAP(CEditSounds)
	ON_BN_CLICKED(IDC_ADDSOUND, OnAddsound)
	ON_BN_CLICKED(IDC_PLAYSOUND, OnPlaysound)
	ON_BN_CLICKED(IDC_PLAYUSEDSOUND, OnPlayusedsound)
	ON_BN_CLICKED(IDC_REMOVESOUND, OnRemovesound)
	ON_LBN_SELCHANGE(IDC_USEDSOUNDS, OnSelchangeUsedsounds)
	ON_EN_KILLFOCUS(IDC_SOUND_CHANNEL, OnKillfocusSoundChannel)
	ON_EN_KILLFOCUS(IDC_SOUND_NUMSAMPLES, OnKillfocusSoundNumsamples)
	ON_EN_KILLFOCUS(IDC_SOUND_PRIORITY, OnKillfocusSoundPriority)
	ON_EN_KILLFOCUS(IDC_SOUND_RANGE, OnKillfocusSoundRange)
	ON_EN_KILLFOCUS(IDC_SOUND_VOLUME, OnKillfocusSoundVolume)
	ON_CBN_SELCHANGE(IDC_COMBO_SOUNDMAPPING, OnSelchangeComboSoundmapping)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditSounds diagnostics

#ifdef _DEBUG
void CEditSounds::AssertValid() const
{
	CFormView::AssertValid();
}

void CEditSounds::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditSounds message handlers

void CEditSounds::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

    m_SoundList.ResetContent();
    m_UsedSoundList.ResetContent();

    int iIndex;

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider I"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR1__);

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider I Gold"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR1GOLD__);

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider II"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR2__);

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider II Gold"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR2GOLD__);

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider III"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR3__);

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider III Gold"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR3GOLD__);

    iIndex = m_ComboSoundMapping.AddString(_T("Sounds mapped to Tomb Raider IV"));
    m_ComboSoundMapping.SetItemData(iIndex, __RESMGR_TR4__);
}


void CEditSounds::vFillLists()
{
    // Get useful data
    CTRFile*        lpTRFile = m_lpDataHandler->GetTRFile();
    CTrSndMgr*      lpSndMgr = lpTRFile->GetTRFile().tr123File.lpSndMgr;
    const CResMgr&  ResMgr = ((CTRViewerApp*)AfxGetApp())->GetResMgr();
    BYTE            bTRResId = (BYTE)m_ComboSoundMapping.GetItemData(m_ComboSoundMapping.GetCurSel());

	bool	boNoUnusedList = lpTRFile->GetTRType() == TR1_FILE  ||  lpTRFile->GetTRType() == TR4_FILE;

    DWORD           dwNumMaxSounds = lpTRFile->GetTRType() == TR1_FILE ? sizeof(TR1_SOUNDMAP) / sizeof(bit16) : sizeof(TR2_SOUNDMAP) / sizeof(bit16);

	if( boNoUnusedList )
		{
		GetDlgItem( IDC_REMOVESOUND )->EnableWindow( FALSE );
		GetDlgItem( IDC_ADDSOUND )->EnableWindow( FALSE );
		GetDlgItem( IDC_PLAYSOUND )->EnableWindow( FALSE );
		}

    // Build the sound lists
    m_SoundList.ResetContent();
    m_UsedSoundList.ResetContent();

    DWORD   dwNumUsedSounds = 0;
    DWORD   dwNumSounds = 0;
    DWORD   dwSound = 0;

    for(CTrSndMgr::MapIdx2Snd::iterator theIter = lpSndMgr->m_SoundMap.begin(); theIter != lpSndMgr->m_SoundMap.end(); theIter++)
        {
        DWORD   dwInternalIndex = theIter->first;
        CTrSndMgr::CTrSnd* lpSnd = theIter->second;

        CString s;

        // Fill the unused sound list
		for(DWORD dwI = dwSound; dwI < dwInternalIndex; dwI++)
			{
			s = ResMgr.cstrGetSfxName(bTRResId,dwI);

			if( !boNoUnusedList )
				{
				int iIndex = m_SoundList.AddString(s);
				m_SoundList.SetItemData(iIndex,dwI);
				}

			dwNumSounds++;
			}

        // Fill the used sound list
        dwSound = dwInternalIndex + 1;

        s = ResMgr.cstrGetSfxName(bTRResId,dwInternalIndex);

        int iIndex = m_UsedSoundList.AddString(s);
        m_UsedSoundList.SetItemData(iIndex,(DWORD)lpSnd);

        dwNumUsedSounds++;
        }

    // Finish the unused sound list
    for(DWORD dwI = dwSound; dwI < dwNumMaxSounds; dwI++)
        {
        CString s;

        s = ResMgr.cstrGetSfxName(bTRResId,dwI);

		if( !boNoUnusedList )
			{
			int iIndex = m_SoundList.AddString(s);
			m_SoundList.SetItemData(iIndex,dwI);
			}

        dwNumSounds++;
        }

	if( boNoUnusedList ) dwNumSounds = 0;

    m_dwNumSounds = dwNumSounds;
    m_dwNumUsedSounds = dwNumUsedSounds;

    UpdateData(FALSE);
}


void CEditSounds::vSetDataTypeHandler(CHandleSounds* lpHandler)
{
    m_lpDataHandler = lpHandler;

    if(!m_lpDataHandler) return;

    // Get useful data
    CTRFile*        lpTRFile = m_lpDataHandler->GetTRFile();
    const CResMgr&  ResMgr = ((CTRViewerApp*)AfxGetApp())->GetResMgr();
    BYTE            bTRResId = ResMgr.bGetResId(lpTRFile->GetTRType());

    // Select the right item in the "mapping" combo
    for(DWORD dwI = 0; dwI < (DWORD)m_ComboSoundMapping.GetCount(); dwI++)
        {
        DWORD   dwResId = m_ComboSoundMapping.GetItemData(dwI);

        if(bTRResId == dwResId)
            {
            m_ComboSoundMapping.SetCurSel(dwI);
            break;
            }
        }

    vFillLists();
}

void CEditSounds::OnAddsound() 
{
    // Get the selected unused sound
    int iSel = m_SoundList.GetCurSel();
    if(iSel == LB_ERR) return;

    // Get useful data
    CString         s;
    CTRFile*        lpTRFile = m_lpDataHandler->GetTRFile();
    CTrSndMgr*      lpSndMgr = lpTRFile->GetTRFile().tr123File.lpSndMgr;
    const CResMgr&  ResMgr = ((CTRViewerApp*)AfxGetApp())->GetResMgr();
    BYTE            bTRResId = (BYTE)m_ComboSoundMapping.GetItemData(m_ComboSoundMapping.GetCurSel());

    DWORD           dwInternalIndex = m_SoundList.GetItemData(iSel);

    // Delete the sound from the unused sound list
    m_SoundList.DeleteString(iSel);

    // Add the sound to the used sound list
    s = ResMgr.cstrGetSfxName(bTRResId, dwInternalIndex);

    int iIndex = m_UsedSoundList.AddString(s);

    // Build a TR2_SOUND_DETAILS for this sound
    TR2_SOUND_DETAILS   SoundDetail;

    SoundDetail.sUnknown1   = 0;
    SoundDetail.sUnknown2   = (bit16)(ResMgr.dwGetSfxNumSamples(bTRResId,dwInternalIndex) << 2);
    SoundDetail.sVolume     = (short) 32767;

    // Add the sound to the sound manager
    CTrSndMgr::CTrSnd* lpSnd = new CTrSndMgr::CTrSnd(&SoundDetail,ResMgr.dwGetSfxFirstSoundIndex(bTRResId,dwInternalIndex),dwInternalIndex);

    lpSndMgr->boAddSound(lpSnd);

    m_UsedSoundList.SetItemData(iIndex,(DWORD)lpSnd);

    // Update sound counts
    m_dwNumSounds--;
    m_dwNumUsedSounds++;

	UpdateData(FALSE);

    m_lpDataHandler->vSetChanged();
}

void CEditSounds::OnRemovesound() 
{
    // Get the selected used sound
    int iSel = m_UsedSoundList.GetCurSel();
    if(iSel == LB_ERR) return;

    // Get useful data
    CString             s;
    CTRFile*            lpTRFile = m_lpDataHandler->GetTRFile();
    CTrSndMgr*          lpSndMgr = lpTRFile->GetTRFile().tr123File.lpSndMgr;
    const CResMgr&      ResMgr = ((CTRViewerApp*)AfxGetApp())->GetResMgr();
    BYTE                bTRResId = (BYTE)m_ComboSoundMapping.GetItemData(m_ComboSoundMapping.GetCurSel());

    CTrSndMgr::CTrSnd*  lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);
    DWORD               dwInternalIndex = lpSnd->m_dwInternalIndex;

    // Delete the sound from the used sound list
    m_UsedSoundList.DeleteString(iSel);

    // Add the sound to the unused sound list
    s = ResMgr.cstrGetSfxName(bTRResId,dwInternalIndex);

    int iIndex = m_SoundList.AddString(s);

    m_SoundList.SetItemData(iIndex,dwInternalIndex);

    // Remove the sound from the sound manager
    lpSndMgr->vRemoveSound(dwInternalIndex);

    // Update sound counts
    m_dwNumSounds++;
    m_dwNumUsedSounds--;

	UpdateData(FALSE);

    m_lpDataHandler->vSetChanged();
}

void    vPlaySound(CString& cstrPath, DWORD dwSampleIndex, CTRFile* lpTRFile = NULL)
{
	CWaitCursor	dummy;

	if( lpTRFile  &&  lpTRFile->GetTRType() == TR4_FILE )
		{
        PlaySound((LPCTSTR)lpTRFile->GetTRFile().tr123File.lpSounds[dwSampleIndex].lpbData, NULL, SND_MEMORY | SND_SYNC);

		return;
		}

	if( lpTRFile  &&  lpTRFile->GetTRType() == TR1_FILE )
		{
        PlaySound((LPCTSTR)&lpTRFile->GetTRFile().tr123File.lpSamples[dwSampleIndex], NULL, SND_MEMORY | SND_SYNC);

		return;
		}

    // Open the SFX file
    HANDLE hSrcFile = CreateFile(cstrPath,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

    if(hSrcFile  ==  INVALID_HANDLE_VALUE)
        {
        CString s;
        s.Format(_T("Can't play the sound because the file %s can't be found.\n"),cstrPath);
        AfxMessageBox(s,MB_ICONSTOP | MB_OK  | MB_TOPMOST);
        return;
        }

    BYTE*   lpbWav = NULL;

    dwSampleIndex++;

    // Loop through the samples until we found the right one
    while(dwSampleIndex--)
        {
        DWORD   dwHeader[2];
        DWORD   dwNbRead;

        // Read the .WAV header
        if(!ReadFile(hSrcFile,&dwHeader,8,&dwNbRead,NULL)) break;

        if(dwSampleIndex == 0)
            {
            // We have reached the right sample, read the wav into our buffer
            lpbWav = new BYTE [ dwHeader[1] + 8];

            ReadFile(hSrcFile,&lpbWav[8],dwHeader[1],&dwNbRead,NULL);

            memcpy(lpbWav, &dwHeader, 8);
            }
        else
            {
            // Not the right sample: move to the next one
            SetFilePointer(hSrcFile, dwHeader[1], NULL, FILE_CURRENT);
            }
        }

    // Found the sample ?
    if(lpbWav)
        {
        // Yes, play it
        PlaySound((LPCTSTR)lpbWav, NULL, SND_MEMORY | SND_SYNC);

        delete lpbWav;
        }

    CloseHandle(hSrcFile);
}

void CEditSounds::OnPlaysound() 
{
    // Get the selected unused sound
    int iSel = m_SoundList.GetCurSel();
    if(iSel == LB_ERR) return;

    // Get useful data
    CTRFile*        lpTRFile = m_lpDataHandler->GetTRFile();
    const CResMgr&  ResMgr = ((CTRViewerApp*)AfxGetApp())->GetResMgr();
    BYTE            bTRResId = (BYTE)m_ComboSoundMapping.GetItemData(m_ComboSoundMapping.GetCurSel());

    DWORD           dwInternalIndex = m_SoundList.GetItemData(iSel);

    // Get the sample index to play
    DWORD   dwSampleIndex = ResMgr.dwGetSfxFirstSoundIndex(bTRResId, dwInternalIndex);


    // Build the path to the Main.sfx file to use
    CString cstrPath(ResMgr.cstrGetDataPath(bTRResId));

    cstrPath += _T("Main.sfx");

    // Play the sound
    vPlaySound(cstrPath, dwSampleIndex);
}

void CEditSounds::OnPlayusedsound() 
{
    // Get the selected used sound
    int iSel = m_UsedSoundList.GetCurSel();
    if(iSel == LB_ERR) return;

    // Get useful data
    CTRFile*            lpTRFile = m_lpDataHandler->GetTRFile();
    const CResMgr&      ResMgr = ((CTRViewerApp*)AfxGetApp())->GetResMgr();
    BYTE                bTRResId = (BYTE)m_ComboSoundMapping.GetItemData(m_ComboSoundMapping.GetCurSel());

    CTrSndMgr::CTrSnd*  lpSnd  = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);
    DWORD               dwInternalIndex = lpSnd->m_dwInternalIndex;

    // Get the sample index to play
    DWORD   dwSampleIndex = lpTRFile->GetTRType() == TR4_FILE ? lpSnd->sGetSample() : lpSnd->dwGetFirstSoundIndex();

    // Build the path to the Main.sfx file to use
    CString cstrPath(ResMgr.cstrGetDataPath(bTRResId));

    cstrPath += _T("Main.sfx");

    // Play the sound
    vPlaySound(cstrPath, dwSampleIndex, lpTRFile);
}

void CEditSounds::OnSelchangeUsedsounds() 
{
    // Get the selected used sound
    int iSel = m_UsedSoundList.GetCurSel();
    if(iSel == LB_ERR) return;

    // Display informations about the selected sound
    CTrSndMgr::CTrSnd* lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);

	m_dwNumSamples      = lpSnd->m_wNumSounds;
	m_dwPriority        = (lpSnd->m_sUnknown2 & 0xFF00) >> 8;
	m_lRange            = lpSnd->m_sUnknown1;
	m_dwChannel         = lpSnd->m_sUnknown2 & 0x03;
	m_lVolume           = lpSnd->m_lVolume;
    m_dwFirstIndex      = lpSnd->m_dwFirstSoundIndex;
    m_dwInternalIndex   = lpSnd->m_dwInternalIndex;

    UpdateData(FALSE);
}

void CEditSounds::OnSelchangeComboSoundmapping() 
{
    vFillLists();
}

void CEditSounds::OnKillfocusSoundChannel() 
{
    int iSel = m_UsedSoundList.GetCurSel();

    if(iSel == LB_ERR) return;

    CTrSndMgr::CTrSnd* lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);

    UpdateData(TRUE);

    lpSnd->m_sUnknown2 = (short)((lpSnd->m_sUnknown2 & 0xFFFC) + m_dwChannel);
}

void CEditSounds::OnKillfocusSoundNumsamples() 
{
    int iSel = m_UsedSoundList.GetCurSel();

    if(iSel == LB_ERR) return;

    CTrSndMgr::CTrSnd* lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);

    UpdateData(TRUE);

    lpSnd->m_wNumSounds = (WORD)m_dwNumSamples;
    lpSnd->m_sUnknown2 = (short)((lpSnd->m_sUnknown2 & 0xFF03) + (m_dwNumSamples << 2));
}

void CEditSounds::OnKillfocusSoundPriority() 
{
    int iSel = m_UsedSoundList.GetCurSel();

    if(iSel == LB_ERR) return;

    CTrSndMgr::CTrSnd* lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);

    UpdateData(TRUE);

    lpSnd->m_sUnknown2 = (short)((lpSnd->m_sUnknown2 & 0x00FF) + (m_dwPriority << 8));
}

void CEditSounds::OnKillfocusSoundRange() 
{
    int iSel = m_UsedSoundList.GetCurSel();

    if(iSel == LB_ERR) return;

    CTrSndMgr::CTrSnd* lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);

    UpdateData(TRUE);

    lpSnd->m_sUnknown1 = (short)m_lRange;
}

void CEditSounds::OnKillfocusSoundVolume() 
{
    int iSel = m_UsedSoundList.GetCurSel();

    if(iSel == LB_ERR) return;

    CTrSndMgr::CTrSnd* lpSnd = (CTrSndMgr::CTrSnd*) m_UsedSoundList.GetItemData(iSel);

    UpdateData(TRUE);

    lpSnd->m_lVolume = m_lVolume;
}
