// EditTile.cpp : implementation file
//

#include "stdafx.h"

#include "Resource.h"
#include "ChildFrm.h"
#include "HandleBase.h"
#include "HandleTile.h"
#include "EditBase.h"
#include "EditTile.h"

#include "TextureTools.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditTile

IMPLEMENT_DYNCREATE(CEditTile, CFormView)

CEditTile::CEditTile()
	: CEditBase(CEditTile::IDD)
{
	//{{AFX_DATA_INIT(CEditTile)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
    m_lpDataHandler = NULL;
    m_hBitmap       = NULL;
}

CEditTile::~CEditTile()
{
    vRelease();
}

void CEditTile::vRelease()
{
    if(m_hBitmap) DeleteObject(m_hBitmap);

    m_hBitmap = NULL;
    m_lpDataHandler = NULL;
}


void CEditTile::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditTile)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditTile, CFormView)
	//{{AFX_MSG_MAP(CEditTile)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditTile diagnostics

#ifdef _DEBUG
void CEditTile::AssertValid() const
{
	CFormView::AssertValid();
}

void CEditTile::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditTile message handlers

void CEditTile::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

    SetScrollSizes(MM_TEXT,CSize(256 + 7 * 2,256 + 7 * 2));
}


void CEditTile::vSetDataTypeHandler(CHandleTile* lpHandler)
{
    vRelease();

    m_lpDataHandler = lpHandler;

    InvalidateRect(NULL);
}


//    static long lNum = 0;

void CEditTile::OnDraw(CDC* pDC) 
{
    if(!m_lpDataHandler) return;

    BYTE*           lpTile          = (BYTE*)m_lpDataHandler->GetTile();
    TR4_COMPR_TEXTURE* lpTileTR4    = (TR4_COMPR_TEXTURE*)m_lpDataHandler->GetTile();
    enumTileType    TileType        = m_lpDataHandler->GetTileType();

    if(!m_hBitmap)
        {
        CWaitCursor dummy;
        switch(TileType)
            {
            //
            case TILE_256x256_16:
                {
                BITMAPINFO bmi={{sizeof(BITMAPINFOHEADER),256,256,1,32,BI_RGB,0,0,0,0,0}};
                BYTE* pdata;
                m_hBitmap = ::CreateDIBSection(NULL,&bmi,DIB_RGB_COLORS,(void**)&pdata,NULL,0);
                if(m_hBitmap  &&  pdata)
                    {
                    vPromoteTo32Bits(lpTile,256,256,16,NULL,(BYTE*)pdata);
                    }
                else
                    {
                    CString s;
                    s.Format(_T("Can't create DIB Section (error %ld)"),GetLastError());
                    AfxMessageBox(s);
                    }
                break;
                }
            //
            case TILE_256xY_32:
                {
                BYTE*   lpabDataUncomp = NULL;
                DWORD   dwHeight = 0;

                vUncompressTexture(lpTileTR4,true,&lpabDataUncomp,&dwHeight);

                BITMAPINFO bmi={{sizeof(BITMAPINFOHEADER),256,dwHeight,1,32,BI_RGB,0,0,0,0,0}};
                BYTE* pdata;
                m_hBitmap = ::CreateDIBSection(NULL,&bmi,DIB_RGB_COLORS,(void**)&pdata,NULL,0);

                if(m_hBitmap  &&  pdata)
                    {
                    vPromoteTo32Bits(lpabDataUncomp,256,dwHeight,32,NULL,(BYTE*)pdata);
                    }
                else
                    {
                    CString s;
                    s.Format(_T("Can't create DIB Section (error %ld)"),GetLastError());
                    AfxMessageBox(s);
                    }

                delete [] lpabDataUncomp;

                SetScrollSizes(MM_TEXT,CSize(256 + 7 * 2,dwHeight + 7 * 2));
                break;
                }
            //
            case TILE_256xY_16:
                {
                BYTE*   lpabDataUncomp = NULL;
                DWORD   dwHeight = 0;

                vUncompressTexture(lpTileTR4,false,&lpabDataUncomp,&dwHeight);

                BITMAPINFO bmi={{sizeof(BITMAPINFOHEADER),256,dwHeight,1,32,BI_RGB,0,0,0,0,0}};
                BYTE* pdata;
                m_hBitmap = ::CreateDIBSection(NULL,&bmi,DIB_RGB_COLORS,(void**)&pdata,NULL,0);
            
                if(m_hBitmap  &&  pdata)
                    {
                    vPromoteTo32Bits(lpabDataUncomp,256,dwHeight,16,NULL,(BYTE*)pdata);
                    }
                else
                    {
                    CString s;
                    s.Format(_T("Can't create DIB Section (error %ld)"),GetLastError());
                    AfxMessageBox(s);
                    }

                delete [] lpabDataUncomp;

                SetScrollSizes(MM_TEXT,CSize(256 + 7 * 2,dwHeight + 7 * 2));
                break;
                }
            }
        }

    if(m_hBitmap) vDrawBitmap(pDC,m_hBitmap,7,7);
}
