#include "stdafx.h"

#include "Resource.h"
//#include "3DSStuff.h"
//#include "TGAFile.h"
//#include "TextureTools.h"

#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "TRAnimTrack.h"
#include "AnimMgr.h"

#include "FSceneFormat.h"

extern bool boGetAnimsData( CTrMvb& trMVB, DWORD dwAnimId, 
                            DWORD& dwNumMeshes, DWORD& dwNumFrames, DWORD& dwAnimNumKeys, DWORD& dwAnimFrameRate, 
                            CVect3D** lplpTransRootMesh, CQuaternion** lplpRotMeshes );

//
//
// Export moveable to Fairy
//
//
bool boExportMoveableToFairy(CTrMvb& trMVB,TCHAR* lpszFairyName,TCHAR* lpszTextureName,CTRFile* lpTRFile,DWORD dwNumTrack)
{
    // Extract the name of the moveable from the path
    TCHAR lpszObjName[_MAX_FNAME];
    TCHAR szDrive    [_MAX_DRIVE];
    TCHAR szDir      [_MAX_DIR];

    _tsplitpath(lpszFairyName,szDrive,szDir,lpszObjName,NULL);

    // create anim file
    FILE* pFKeys = _tfopen(lpszFairyName,_T("wb"));
    if(!pFKeys) return false;

    // Inits
    float fMinX = 1e20f, fMaxX = -1e20f;
    float fMinY = 1e20f, fMaxY = -1e20f;
    float fMinZ = 1e20f, fMaxZ = -1e20f;

    bool boOk = true;

    #define STACK_DEPTHMAX 10
    bool    StackIsDummy[STACK_DEPTHMAX];
    DWORD   Stack[STACK_DEPTHMAX];
    float   StackTrans[3 * STACK_DEPTHMAX];
    float   fTransX=0, fTransY=0, fTransZ=0;
    DWORD   dwStackPointer=0;

    TR2_MESHTREE* lpMeshTree = trMVB.m_lpMeshTree;
    DWORD   dwParent = 0;
    bool    boParentIsDummy = trMVB.m_lpLstMeshes[0].boIsDummy;

    DWORD   dwNumAnimsId = 1;
    DWORD*  lpLstAnimsId = new DWORD[dwNumAnimsId];

    lpLstAnimsId[0] = dwNumTrack;

    DWORD   dwNumMeshes = trMVB.m_dwNumMeshes;

    DWORD   dwNumTotFrames          = 0;
    DWORD   dwNumTotKeys            = 0;
    DWORD   dwNumFramesAnimFirst    = 0;
    DWORD   dwNumFramesAnimLast     = 0;

    DWORD   dwAnimLength = 0;
    DWORD   dwAnimBegin  = 0;
    DWORD   dwAnimEnd    = 0;

    // header

    if( dwNumTrack != -1 )
        {
        for( DWORD dwTrack = 0; dwTrack < dwNumAnimsId; dwTrack++ )
            {
            CAnimTrack* lpTrack = trMVB.lpGetAnimMgr()->lpGetTrack( lpLstAnimsId[ dwTrack ] );

            _ASSERTE( lpTrack );

            dwNumTotFrames  += lpTrack->dwGetNumFrames();
            dwNumTotKeys    += lpTrack->dwGetNumKeys();
            dwNumTotKeys++; // the 1st key is duplicated at the end of the anim

            if( dwTrack == 0 ) dwNumFramesAnimFirst = lpTrack->dwGetNumFrames();
            if( dwTrack == dwNumAnimsId - 1 ) dwNumFramesAnimLast = lpTrack->dwGetNumFrames();
            }

        dwNumTotKeys += dwNumAnimsId - 1;

        dwAnimLength = (dwNumAnimsId - 1) * 1000 + dwNumFramesAnimLast - 1;
        dwAnimBegin  = 0;
        dwAnimEnd    = dwNumFramesAnimFirst - 1;
        }

    ANIMFILEHEADER AnimFileHeader;
    AnimFileHeader.u32Version    = 0x100;
    AnimFileHeader.u32FirstFrame = dwAnimBegin;
    AnimFileHeader.u32LastFrame  = dwAnimEnd+1;
    AnimFileHeader.u32FrameSpeed = 30;
    AnimFileHeader.u32FrameTicks = 160;
    AnimFileHeader.u32NbAnims    = dwNumMeshes;

    fwrite(&AnimFileHeader,sizeof(AnimFileHeader),1,pFKeys);

    //

    for(DWORD dwI = 0; dwI < dwNumMeshes; dwI++)
        {
        bool boIsDummy = trMVB.m_lpLstMeshes[dwI].boIsDummy;

        if( !boIsDummy )
            wsprintf(lpszObjName,__TEXT("M%.3d"),dwI);
        else
            wsprintf(lpszObjName,__TEXT("dummy%.3d"),dwI);

        if( dwNumTrack != -1 )
            {
            //InitObjectMotion3ds(&objMotion,dwI ? 1 : dwNumTotKeys,dwNumTotKeys,1,0,0);
            }
        else
            {
            //InitObjectMotion3ds(&objMotion,1,1,1,0,0);
            }

        char szMotionName[256];
        char szParentName[256];
        CVect3D v3Pos0;

        if( !boIsDummy )
            sprintf(szMotionName,"M%.3d",dwI);
        else
            sprintf(szMotionName,"dummy%.3d",dwI);

        if(dwI)
            {
            bitu32  dwStack = lpMeshTree->lCoord; lpMeshTree++;
            bit32   lTransX = lpMeshTree->lCoord; lpMeshTree++;
            bit32   lTransY = lpMeshTree->lCoord; lpMeshTree++;
            bit32   lTransZ = lpMeshTree->lCoord; lpMeshTree++;

            if(dwStack & 1)
                {
                dwStackPointer--;
                dwParent = Stack[dwStackPointer];
                boParentIsDummy = StackIsDummy[ dwStackPointer ];
                fTransX = StackTrans[dwStackPointer*3 + 0];
                fTransY = StackTrans[dwStackPointer*3 + 1];
                fTransZ = StackTrans[dwStackPointer*3 + 2];
                }

            if(dwStack & 2)
                {
                StackIsDummy[dwStackPointer] = boParentIsDummy;
                Stack[dwStackPointer] = dwParent;
                StackTrans[dwStackPointer*3 + 0] = fTransX;
                StackTrans[dwStackPointer*3 + 1] = fTransY;
                StackTrans[dwStackPointer*3 + 2] = fTransZ;
                dwStackPointer++;
                }

            fTransX +=  (float)lTransX;
            fTransY +=  (float)lTransY;
            fTransZ +=  (float)lTransZ;

            if(dwParent != -1)
                {
                if( !boParentIsDummy )
                    sprintf(szParentName,"M%.3d",dwParent);
                else
                    sprintf(szParentName,"dummy%.3d",dwParent);
                }

            v3Pos0[0] = (float)lTransX;   // Convert TR coordinates to 3DS (file) coordinates
            v3Pos0[1] = (float)lTransZ;
            v3Pos0[2] = (float)-lTransY;
            }

        // anim header

        ANIMHEADER AnimHeader;
        AnimHeader.u32Type      = KEYFRAME;
        strncpy(AnimHeader.szName,szMotionName,32);
        AnimHeader.szName[31]   = 0;
        AnimHeader.u32PosKeys   = (dwI ? 0 : dwNumTotKeys);
        AnimHeader.u32RotKeys   = dwNumTotKeys;
        AnimHeader.u32ScaleKeys = 0;

        if(dwNumTrack == -1)
          {
          AnimHeader.u32PosKeys = AnimHeader.u32RotKeys = AnimHeader.u32ScaleKeys = 0;
          }

        fwrite(&AnimHeader,sizeof(AnimHeader),1,pFKeys);

        //

        if( dwNumTrack != -1 )
            {
            DWORD           dwBaseTime  = 0;
            DWORD           dwBaseKey   = 0;

            for( DWORD dwAnimId = 0; dwAnimId < dwNumAnimsId; dwAnimId++ )
                {
                DWORD           dwDummy;
                DWORD           dwNumFrames;
                DWORD           dwAnimNumKeys;
                DWORD           dwAnimFrameRate;
                CVect3D*        lpTransRootMesh;
                CQuaternion*    lpRotMeshes;

                boGetAnimsData( trMVB, lpLstAnimsId[ dwAnimId ], dwDummy, dwNumFrames, dwAnimNumKeys, dwAnimFrameRate, &lpTransRootMesh, &lpRotMeshes );
                dwAnimNumKeys++;  // copy 1st key to end of anim

                u32 u32KeyMax  = 0;
                for(u32 u32Key = 0; u32Key < dwAnimNumKeys-1; u32Key++)
                  {
                  u32 u32Time = u32Key*dwAnimFrameRate;
                  if(u32Time >= dwNumFrames) break;         // other keys are skipped
                  u32KeyMax++;
                  }

                // 1st mesh: only one having a position track

                if( dwI == 0 )
                    {
                    POSHEADER PosHeader;
                    PosHeader.u32Type = SAMPLE;
                    PosHeader.u32Keys = u32KeyMax+1; //dwAnimNumKeys;
                    fwrite(&PosHeader,sizeof(PosHeader),1,pFKeys);

                    for(DWORD dwKey = 0; dwKey < dwAnimNumKeys; dwKey++)
                        {
                        if((dwKey >= u32KeyMax) && (dwKey != dwAnimNumKeys-1)) continue;

                        u32 u32Time = dwBaseTime + dwKey * dwAnimFrameRate;
                        if(dwKey == dwAnimNumKeys-1) u32Time = dwBaseTime + dwNumFrames;
                        //u32Time *= 160;
                        f32 f32Time = u32Time/30.f;
                        fwrite(&f32Time,sizeof(f32),1,pFKeys);

                        CVect3D v3Val(lpTransRootMesh[dwKey][0],-lpTransRootMesh[dwKey][2],lpTransRootMesh[dwKey][1]);
                        v3Val *= 1.75f/780.f;     // scale to meters
                        v3Val[2] -= 0.95f;          // translate vertically
                        fwrite(&v3Val,sizeof(CVect3D),1,pFKeys);
/*
                        CVect3D v3TCB(0.f);
                        fwrite(&v3TCB,sizeof(CVect3D),1,pFKeys);

                        CVect2D v2Ease(0.f);
                        fwrite(&v2Ease,sizeof(CVect2D),1,pFKeys);*/
                        }

//                    objMotion->pkeys[dwBaseKey + dwAnimNumKeys - 1].time = dwBaseTime + dwNumFrames - 1;

                    if( dwAnimId != dwNumAnimsId - 1 )
                        {/*
                        objMotion->pos[dwBaseKey + dwAnimNumKeys].x = 0;
                        objMotion->pos[dwBaseKey + dwAnimNumKeys].y = 0;
                        objMotion->pos[dwBaseKey + dwAnimNumKeys].z = 0;
                        objMotion->pkeys[dwBaseKey + dwAnimNumKeys].time = dwBaseTime + 999;
                        objMotion->pkeys[dwBaseKey + dwAnimNumKeys].rflags = 0x1F;
                        objMotion->pkeys[dwBaseKey + dwAnimNumKeys].tension = 0.0f;
                        objMotion->pkeys[dwBaseKey + dwAnimNumKeys].continuity = 0.0f;
                        objMotion->pkeys[dwBaseKey + dwAnimNumKeys].bias = 0.0f;*/
                        }
                    }

                // rotation track

                CQuaternion QuatPrev(0.0,0.0,0.0,1.0);

                CQuaternion*    lpQuat;
                CVect3D         vecAxis;
                FLOAT           fAngle;
                CQuaternion     Quat;

                ROTHEADER RotHeader;
                RotHeader.u32Type = SAMPLE;
                RotHeader.u32Keys = u32KeyMax+1; //dwAnimNumKeys;
                fwrite(&RotHeader,sizeof(RotHeader),1,pFKeys);

                for(DWORD dwKey = 0; dwKey < dwAnimNumKeys; dwKey++)
                    {
                    if((dwKey >= u32KeyMax) && (dwKey != dwAnimNumKeys-1)) continue;

                    lpQuat = &lpRotMeshes[dwKey * dwNumMeshes + dwI];
                    Quat = (*lpQuat) * QuatPrev.quatConjugate();
                    Quat.vToAxisAngle(&vecAxis,&fAngle);
                    vecAxis.boNormalize1();
                    QuatPrev = *lpQuat;

                    u32 u32Time = dwBaseTime + dwKey * dwAnimFrameRate;
                    if(dwKey == dwAnimNumKeys-1) u32Time = dwBaseTime + dwNumFrames;
                    //u32Time *= 160;
                    f32 f32Time = u32Time/30.f;
                    fwrite(&f32Time,sizeof(f32),1,pFKeys);

                    CQuaternion qRot(*lpQuat);
                    qRot.vToAxisAngle(&vecAxis,&fAngle);
                    vecAxis.boNormalize1();
                    CVect3D v3Tmp(vecAxis[0],-vecAxis[2],vecAxis[1]);
                    qRot.vFromAxisAngle(v3Tmp,-fAngle);
                    fwrite(&qRot,sizeof(CQuaternion),1,pFKeys);
/*
                    CVect3D v3TCB(0.f);
                    fwrite(&v3TCB,sizeof(CVect3D),1,pFKeys);

                    CVect2D v2Ease(0.f);
                    fwrite(&v2Ease,sizeof(CVect2D),1,pFKeys);*/
                    }

//                objMotion->rkeys[dwBaseKey + dwAnimNumKeys - 1].time = dwBaseTime + dwNumFrames - 1;

                if( dwAnimId != dwNumAnimsId - 1 )
                    {/*
                    Quat = (*lpQuat).quatConjugate();
                    Quat.vToAxisAngle(&vecAxis,&fAngle);
                    vecAxis.boNormalize1();

                    objMotion->rot[dwBaseKey + dwAnimNumKeys].angle = -fAngle;
                    objMotion->rot[dwBaseKey + dwAnimNumKeys].x = vecAxis[0];   // Convert OGL coordinates to 3DS (file) coordinates
                    objMotion->rot[dwBaseKey + dwAnimNumKeys].y = -vecAxis[2];
                    objMotion->rot[dwBaseKey + dwAnimNumKeys].z = vecAxis[1];
                    objMotion->rkeys[dwBaseKey + dwAnimNumKeys].time = dwBaseTime + 999;
                    objMotion->rkeys[dwBaseKey + dwAnimNumKeys].rflags = 0x1F;
                    objMotion->rkeys[dwBaseKey + dwAnimNumKeys].tension = 0.0f;
                    objMotion->rkeys[dwBaseKey + dwAnimNumKeys].continuity = 0.0f;
                    objMotion->rkeys[dwBaseKey + dwAnimNumKeys].bias = 0.0f;*/
                    }

                dwBaseTime += 1000;
                dwBaseKey += dwAnimNumKeys + 1;

                delete [] lpTransRootMesh;
                delete [] lpRotMeshes;
                }
            }

        //

        dwParent = dwI;
        boParentIsDummy = boIsDummy;
        }

    //

    fclose(pFKeys);
    return true;
}
