// TRViewer.h : main header file for the TRVIEWER application
//

#if !defined(AFX_TRVIEWER_H__903546D7_E15E_11D3_AA54_00105A49000B__INCLUDED_)
#define AFX_TRVIEWER_H__903546D7_E15E_11D3_AA54_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "ResMgr.h"

/////////////////////////////////////////////////////////////////////////////
// CTRViewerApp:
// See TRViewer.cpp for the implementation of this class
//

class CTRViewerApp : public CWinApp
{
public:
	CTRViewerApp();

    const CResMgr& GetResMgr()   const   { return m_ResMgr; }

	bool	boShowFriendlyNamesInTreeview() const { return m_dwShowFriendlyNamesInTreeview != 0; }
	bool	boShowIconItems()				const { return m_dwShowIconItems != 0; }
	bool	boShowRealMeshes()				const { return m_dwShowRealMeshes != 0; }
	bool	boShowAssociatedMoveable()		const { return m_dwShowAssociatedMoveable != 0; }
	bool	boSaveUncompressedSounds()		const { return m_dwSaveUncompressedSounds != 0; }

	void	vSetShowFriendlyNamesInTreeview( bool boShow )	{ m_dwShowFriendlyNamesInTreeview = boShow ? 1 : 0; WriteProfileInt(_T("Settings"),_T("ShowFriendlyNamesInTreeview"),boShow ? 1 : 0); }
	void	vSetShowIconItems( bool boShow )				{ m_dwShowIconItems = boShow ? 1 : 0; WriteProfileInt(_T("Settings"),_T("ShowIconInFrontOfItemInTreeview"),boShow ? 1 : 0); }
	void	vSetShowRealMeshes( bool boShow )				{ m_dwShowRealMeshes = boShow ? 1 : 0; WriteProfileInt(_T("Settings"),_T("ShowRealMeshes"),boShow ? 1 : 0); }
	void	vSetShowAssociatedMoveable( bool boShow )		{ m_dwShowAssociatedMoveable = boShow ? 1 : 0; WriteProfileInt(_T("Settings"),_T("ShowAssociatedMoveable"),boShow ? 1 : 0); }
	void	vSetSaveUncompressedSounds( bool boUncomp )		{ m_dwSaveUncompressedSounds = boUncomp ? 1 : 0; WriteProfileInt(_T("Settings"),_T("SaveUncompressedSounds"),boUncomp ? 1 : 0); }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTRViewerApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL OnIdle(LONG lCount);
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CTRViewerApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    CResMgr     m_ResMgr;

	DWORD		m_dwShowFriendlyNamesInTreeview;
	DWORD		m_dwShowIconItems;
	DWORD		m_dwShowRealMeshes;
	DWORD		m_dwShowAssociatedMoveable;
	DWORD		m_dwSaveUncompressedSounds;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRVIEWER_H__903546D7_E15E_11D3_AA54_00105A49000B__INCLUDED_)
