// TRViewerView.cpp : implementation of the CTRViewerView class
//

#include "stdafx.h"

#include "Resource.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "TRViewerDoc.h"
#include "TRViewerView.h"
#include "FileTree.h"
#include "HandleBase.h"
#include "HandleMoveables.h"
#include "HandleStaticMeshes.h"
#include "HandleSprites.h"
#include "EditBase.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTRViewerView

IMPLEMENT_DYNCREATE(CTRViewerView, CFormView)

BEGIN_MESSAGE_MAP(CTRViewerView, CFormView)
	//{{AFX_MSG_MAP(CTRViewerView)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// Standard printing commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTRViewerView construction/destruction

CTRViewerView::CTRViewerView()
	: CFormView(CTRViewerView::IDD)
{
	//{{AFX_DATA_INIT(CTRViewerView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
    m_lpTree = NULL;
}

CTRViewerView::~CTRViewerView()
{
    if(m_lpTree)
        {
        delete m_lpTree;
        }

    m_lpTree = NULL;
}

void CTRViewerView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTRViewerView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CTRViewerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CTRViewerView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	ResizeParentToFit();

    // Resize the view
    CTRViewerDoc* lpDoc = GetDocument();
    CChildFrame*  lpFrame = (CChildFrame*)GetParentFrame();

    // Create the tree control
    m_lpTree = new CFileTree(lpFrame,&lpDoc->GetTRFile(),lpDoc);

    RECT Rect;

    lpFrame->GetClientRect(&Rect);

    m_lpTree->Create(WS_VISIBLE | WS_TABSTOP | WS_CHILD | TVS_HASBUTTONS | TVS_LINESATROOT | TVS_HASLINES/*   | TVS_DISABLEDRAGDROP*/,
        CRect(0, 0, Rect.right-300, Rect.bottom), this, IDC_FILETREE);

    m_lpTree->vInitialize();
}


CView*  CTRViewerView::GetActiveView()
{
    CMDIChildWnd * pChild = ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
    
    if(!pChild) return NULL;
    
    CView* pView = pChild->GetActiveView();

    return pView;
}


bool    CTRViewerView::boSave(LPCTSTR lpszFileName)
{
    return m_lpTree->boSave(lpszFileName);
}

/////////////////////////////////////////////////////////////////////////////
// CTRViewerView diagnostics

#ifdef _DEBUG
void CTRViewerView::AssertValid() const
{
	CFormView::AssertValid();
}

void CTRViewerView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CTRViewerDoc* CTRViewerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTRViewerDoc)));
	return (CTRViewerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTRViewerView message handlers

void CTRViewerView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
    
    SetScaleToFitSize(CSize(cx,cy));

    if(m_lpTree) m_lpTree->SetWindowPos(NULL,0,0,cx,cy,0);	
}


BOOL CTRViewerView::boOnIdle()
{
    BOOL boMore = FALSE;

    CChildFrame* lpFrame = (CChildFrame*)GetParentFrame();

	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = lpFrame->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

	boMore = lpEdit->boOnIdle();

    return boMore;
}

void CTRViewerView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
/*!    CChildFrame* lpFrame = (CChildFrame*)GetParentFrame();

	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = lpFrame->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

    if( ePaneType == eEditPane_Mesh )
        {
        dynamic_cast<CEditMesh*>( lpEdit )->OnActivateView(false,NULL,NULL);
        }
*/	
	CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}


void    CTRViewerView::vSetCameraMode(bool boManual)
{
    CChildFrame* lpFrame = (CChildFrame*)GetParentFrame();

	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = lpFrame->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

	lpEdit->vSetAutomaticCamera(!boManual);
}


void    CTRViewerView::vSetShowAxis(bool boShow)
{
    CChildFrame* lpFrame = (CChildFrame*)GetParentFrame();

	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = lpFrame->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

    lpEdit->vSetShowAxis(boShow);
}


void    CTRViewerView::vSetBkgColor(COLORREF BkgColor)
{
    CChildFrame* lpFrame = (CChildFrame*)GetParentFrame();

	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = lpFrame->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

	lpEdit->vSetBkgColor(BkgColor);
}


void    CTRViewerView::vResetRightView(bool boReexpandTree)
{
    CChildFrame* lpFrame = (CChildFrame*)GetParentFrame();

	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = lpFrame->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

	lpEdit->vRelease();

    lpFrame->vSetEditPaneType( eEditPane_None );

    if(boReexpandTree)
        {
        if(m_lpTree->m_lpHandleMoveables    &&  m_lpTree->m_lpHandleMoveables->boIsExpanded())       m_lpTree->m_lpHandleMoveables->vExpandTree(true);
        if(m_lpTree->m_lpHandleStaticMeshes &&  m_lpTree->m_lpHandleStaticMeshes->boIsExpanded())    m_lpTree->m_lpHandleStaticMeshes->vExpandTree(true);
        if(m_lpTree->m_lpHandleSprites      &&  m_lpTree->m_lpHandleSprites->boIsExpanded())         m_lpTree->m_lpHandleSprites->vExpandTree(true);
        }
}


void	CTRViewerView::vShowIconsInTreeview( bool boShow )
{
	if( m_lpTree ) m_lpTree->vShowIcons( boShow );
}


/*static*/ CTRViewerView*	CTRViewerView::lpGetAndActivateTreeCtrlView()
{
	CChildFrame* pChild = (CChildFrame*) ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();

	if( !pChild ) return NULL;

	pChild->SetActiveView( pChild->lpGetMainView() );

	return pChild->lpGetMainView();
}
