// TlboxMoveableCmd.cpp : implementation file
//

#include "stdafx.h"

#include "trviewer.h"
#include "ChildFrm.h"
#include "HandleBase.h"
#include "HandleMoveable.h"
#include "EditBase.h"
#include "EditMoveable.h"

#include "ToolboxBase.h"
#include "ToolboxItfBase.h"
#include "ToolboxSheet.h"

#include "TlboxMoveableItf.h"
#include "Toolbox2Moveable.h"
#include "TlboxMoveableCmd.h"

#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "AnimMgr.h"
#include "TRAnimTrack.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTlboxMoveableCmd property page

IMPLEMENT_DYNCREATE(CTlboxMoveableCmd, CPropertyPage)

CTlboxMoveableCmd::CTlboxMoveableCmd( CToolboxBase* lpParent ) : CToolboxItfBase(CTlboxMoveableCmd::IDD, lpParent)
{
	//{{AFX_DATA_INIT(CTlboxMoveableCmd)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_lAnmCmdP[0] = 0;
	m_lAnmCmdP[1] = 0;
	m_lAnmCmdP[2] = 0;
	m_lAnmCmdP[3] = 0;

    m_hBitmapNew        = 0;
    m_hBitmapDel        = 0;
    m_hBitmapUp			= 0;
    m_hBitmapDown		= 0;
	m_hBitmapValidate	= 0;
	m_dwCurTrack		= 0;
}

CTlboxMoveableCmd::~CTlboxMoveableCmd()
{
    if(m_hBitmapNew)        DeleteObject(m_hBitmapNew);
    if(m_hBitmapDel)        DeleteObject(m_hBitmapDel);
    if(m_hBitmapUp)			DeleteObject(m_hBitmapUp);
    if(m_hBitmapDown)		DeleteObject(m_hBitmapDown);
    if(m_hBitmapValidate)   DeleteObject(m_hBitmapValidate);
}

void CTlboxMoveableCmd::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTlboxMoveableCmd)
	DDX_Control(pDX, IDC_ANIMCOMMANDS, m_AnimCommands);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_ANMCMD_P1, m_lAnmCmdP[0]);
	DDX_Text(pDX, IDC_ANMCMD_P2, m_lAnmCmdP[1]);
	DDX_Text(pDX, IDC_ANMCMD_P3, m_lAnmCmdP[2]);
	DDX_Text(pDX, IDC_ANMCMD_P4, m_lAnmCmdP[3]);
}


BEGIN_MESSAGE_MAP(CTlboxMoveableCmd, CPropertyPage)
	//{{AFX_MSG_MAP(CTlboxMoveableCmd)
	ON_BN_CLICKED(IDC_ANMCMD_SET, OnAnmcmdSet)
	ON_NOTIFY(NM_CLICK, IDC_ANIMCOMMANDS, OnClickAnimcommands)
	ON_BN_CLICKED(IDC_ANMCMD_ADD, OnAnmCmdNew)
	ON_BN_CLICKED(IDC_ANMCMD_DEL, OnAnmCmdDel)
	ON_BN_CLICKED(IDC_ANMCMD_UP, OnAnmCmdUp)
	ON_BN_CLICKED(IDC_ANMCMD_DOWN, OnAnmCmdDown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTlboxMoveableCmd message handlers

BOOL CTlboxMoveableCmd::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

    // Load the bitmaps
    m_hBitmapNew        = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_NEW));
    m_hBitmapDel        = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_DEL));
    m_hBitmapUp         = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_UP));
    m_hBitmapDown       = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_DOWN));
    m_hBitmapValidate   = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_VALIDATE));

    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_ADD,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapNew);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_DEL,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapDel);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_UP,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapUp);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_DOWN,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapDown);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_SET,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapValidate);

    // Build the anim command list view    
    LVCOLUMN hcoll1 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,47,__TEXT("Cmd"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),0,&hcoll1);

    LVCOLUMN hcoll2 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,69,__TEXT("Param 1"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),1,&hcoll2);

    LVCOLUMN hcoll3 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,69,__TEXT("Param 2"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),2,&hcoll3);

    LVCOLUMN hcoll4 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,69,__TEXT("Param 3"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),3,&hcoll4);

    m_AnimCommands.DeleteAllItems();

    DWORD dwStyle2 = ListView_GetExtendedListViewStyle(m_AnimCommands.m_hWnd);

    dwStyle2 |= LVS_EX_FULLROWSELECT;
    ListView_SetExtendedListViewStyle(m_AnimCommands.m_hWnd, dwStyle2);

	return TRUE;
}


void CTlboxMoveableCmd::vInit( bool boNewMoveable )
{
	GET_TLBOXHANDLER( CHandleMoveable );

	DWORD	dwCurTrack = static_cast< CToolbox2Moveable* >( m_lpParent )->dwGetCurTrack();
	bool	boShowAnimCommands = ( dwCurTrack != 0 )  &&  ( boNewMoveable  ||  ( !boNewMoveable  &&  dwCurTrack != m_dwCurTrack ) );

	if( dwCurTrack == 0  ||  boShowAnimCommands )
		{
		m_AnimCommands.DeleteAllItems();

		m_lAnmCmdP[0] = 0;
		m_lAnmCmdP[1] = 0;
		m_lAnmCmdP[2] = 0;
		m_lAnmCmdP[3] = 0;
		}

	if( boShowAnimCommands )
		{
		m_dwCurTrack = dwCurTrack;

		CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

		if( lpMoveable )
			{
			CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
			CTRAnimTrack*   lpTrack = static_cast< CTRAnimTrack* >( lpAnimMgr->lpGetCurrentTrack() );

			vShowAnimCommands( lpTrack );
			}
		}

    UpdateData( FALSE );
}


void CTlboxMoveableCmd::vShowAnimCommands( CTRAnimTrack* lpTrack )
{
    m_AnimCommands.DeleteAllItems();

    for(DWORD dwI = 0; dwI < lpTrack->dwGetNumAnimCommands(); dwI++)
        {
        CString s;
        const CTRAnimCommand& AnimCmde = lpTrack->GetAnimCommand(dwI);

        DWORD dwNumParams = AnimCmde.wGetNumParams();

        TR2_ANIM_COMMAND    sCmd = AnimCmde.sGetCommand();

        s.Format(_T("%ld"),static_cast<DWORD>(sCmd.sValue));

        int iItem = m_AnimCommands.InsertItem(dwI,s);

        bool boFirstParamIsFrame = CTRAnimCommand::boFirstParamIsFrame( sCmd );

        for(long l = 0; l < (long) dwNumParams; l++)
            {
            TR2_ANIM_COMMAND sParam = AnimCmde.sGetParam((WORD)l);
            long    lValue =  sParam.sValue;

            if(l == 0  &&  boFirstParamIsFrame) lValue++;

            s.Format(_T("%ld"),lValue);
            m_AnimCommands.SetItemText(iItem,l+1,s);
            }
        }
}


void CTlboxMoveableCmd::OnAnmcmdSet() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = static_cast< CToolbox2Moveable* >( m_lpParent )->dwGetCurTrack(); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    CTRAnimCommand& AnimCmde = const_cast<CTRAnimCommand&>(lpTrack->GetAnimCommand(iItem));

    for( DWORD dwJ = 0; dwJ < 4; dwJ++)
        {
        CString s;
        GetDlgItem( IDC_ANMCMD_P1 + dwJ )->GetWindowText( s );
        if( s == _T("") ) s = _T("0");
        GetDlgItem( IDC_ANMCMD_P1 + dwJ )->SetWindowText( s );
        }

    UpdateData(TRUE);

    TR2_ANIM_COMMAND    sOldCmde = AnimCmde.sGetCommand();
    TR_FILE&            trFile = lpHandler->lpGetTRFile()->GetTRFile();

    if(m_lAnmCmdP[0] == ANIMCMD_PLAYSOUNDONFRAME_2)
        {
        if(!trFile.tr123File.lpSndMgr->boHaveSound(m_lAnmCmdP[2] & 0x3FFF))
            {
            CString s;
            s.Format(_T("Can't modify this anim command because the sound with internal index #%ld is not in the sound list !"),m_lAnmCmdP[2] & 0x3FFF);
            AfxMessageBox(s,MB_ICONSTOP | MB_TOPMOST);
            return;
            }
        }

    if(sOldCmde.sValue == ANIMCMD_PLAYSOUNDONFRAME_2)
        {
        lpMoveable->lpGetSndMgr()->vRemoveSound(AnimCmde.sGetParam(1).sValue & 0x3FFF);
        }

    CString s;

    AnimCmde.vSetCommand(TR2_ANIM_COMMAND((bit16)m_lAnmCmdP[0]));

    DWORD   dwNumParams = AnimCmde.wGetNumParams();
    bool    boFirstParamIsFrame = CTRAnimCommand::boFirstParamIsFrame( AnimCmde.sGetCommand() );

    s.Format(_T("%ld"),m_lAnmCmdP[0]);
    m_AnimCommands.SetItemText(iItem,0,s);

    for( DWORD dwI = dwNumParams; dwI < 3; dwI++)
        {
        m_AnimCommands.SetItemText( iItem, dwI + 1, _T("") );
        }

    while(dwNumParams--)
        {
        long    lValue =  m_lAnmCmdP[dwNumParams + 1];

        s.Format(_T("%ld"),lValue);
        m_AnimCommands.SetItemText(iItem,dwNumParams + 1,s);

        if(dwNumParams == 0  &&  boFirstParamIsFrame) lValue--;

        AnimCmde.vSetParam((bit16)dwNumParams, (bit16)lValue);
        }

    if(m_lAnmCmdP[0] == ANIMCMD_PLAYSOUNDONFRAME_2)
        {
        lpMoveable->lpGetSndMgr()->boCopySound(trFile.tr123File.lpSndMgr, m_lAnmCmdP[2] & 0x3FFF);
        }

    UpdateData(FALSE);
}


void CTlboxMoveableCmd::OnClickAnimcommands(NMHDR* pNMHDR, LRESULT* pResult) 
{
	GET_TLBOXHANDLER( CHandleMoveable );

	*pResult = 0;

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = static_cast< CToolbox2Moveable* >( m_lpParent )->dwGetCurTrack(); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    LPNMITEMACTIVATE lpItem = (LPNMITEMACTIVATE) pNMHDR;

    if(!lpItem  ||  lpItem->iItem == -1) return;

    vFillAnimCmdsParams( lpTrack, lpItem->iItem );
}


void CTlboxMoveableCmd::vFillAnimCmdsParams( CTRAnimTrack* lpTrack, int iNumAnmCmde )
{
    CTRAnimCommand& AnimCmde = const_cast<CTRAnimCommand&>(lpTrack->GetAnimCommand(iNumAnmCmde));
    DWORD           dwNumParams = AnimCmde.wGetNumParams();
    int             iParam = 0;

    while( iParam != 4)
        {
        TCHAR   szParam[ 16 + 1 ];

        m_AnimCommands.GetItemText( iNumAnmCmde, iParam, szParam, 16 );
        m_lAnmCmdP[ iParam++ ] = _ttol( szParam );
        }

    UpdateData(FALSE);

    for(DWORD dwI = dwNumParams; dwI < 3; dwI++)
        {
        GetDlgItem( IDC_ANMCMD_P1 + dwI + 1 )->SetWindowText( _T("0") );
        }
}


void CTlboxMoveableCmd::OnAnmCmdDel() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    m_AnimCommands.DeleteItem(iItem);
    lpTrack->vRemoveAnimCommand( iItem );

    UpdateData( FALSE );

    if( iItem < m_AnimCommands.GetItemCount() )
        {
        m_AnimCommands.SetItemState( iItem, LVIS_SELECTED, LVIS_SELECTED );
        }
    else
        {
        m_AnimCommands.SetItemState( m_AnimCommands.GetItemCount() - 1, LVIS_SELECTED, LVIS_SELECTED );
        }
}


void CTlboxMoveableCmd::OnAnmCmdUp() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    if(iItem > 0)
        {
        lpTrack->vSwapAnimCmde( iItem, iItem - 1 );
        vMoveItem( m_AnimCommands, 4, -1 );
        UpdateData( FALSE );
        }
}


void CTlboxMoveableCmd::OnAnmCmdDown() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    if(iItem < m_AnimCommands.GetItemCount() - 1 )
        {
        lpTrack->vSwapAnimCmde( iItem, iItem + 1 );
        vMoveItem( m_AnimCommands, 4, 2 );
        UpdateData( FALSE );
        }
}


void CTlboxMoveableCmd::OnAnmCmdNew() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if (lpTrack == NULL) return;

    CTRAnimCommand  AnimCmde( ANIMCMD_DEATHANIM_0, 0 );

    lpTrack->vPushAnimCommand( AnimCmde );

    vShowAnimCommands( lpTrack );

    m_AnimCommands.SetItemState(m_AnimCommands.GetItemCount() - 1,LVIS_SELECTED,LVIS_SELECTED);

    vFillAnimCmdsParams( lpTrack, m_AnimCommands.GetItemCount() - 1 );
}


void CTlboxMoveableCmd::vMoveItem( CListCtrl& ListCtrl, int iNumSubItems, int iOffset )
{
    int iIndex = -1;
    do
        {
        iIndex = ListCtrl.GetNextItem(iIndex,LVNI_SELECTED);
        if(iIndex == -1) break;

        // Check we don't move the first (if we move up) / the last element (if we move down)
        if((iIndex+iOffset >= 0)  &&  (iIndex+iOffset <= ListCtrl.GetItemCount()))
            {
            TCHAR**  lpListTexts = new TCHAR* [ iNumSubItems ];

            for( int i = 0; i < iNumSubItems; i++)
                {
                lpListTexts[ i ] = new TCHAR[ 128 + 1 ];
                ListCtrl.GetItemText(iIndex,i,lpListTexts[ i ],128);
                }

            int iNewIndex = ListCtrl.InsertItem(iIndex+iOffset,lpListTexts[ 0 ]);

            for( i = 1; i < iNumSubItems; i++)
                {
                ListCtrl.SetItemText(iNewIndex,i,lpListTexts[ i ]);
                delete [] lpListTexts[ i ];
                }

            delete [] lpListTexts;

            ListCtrl.SetItemState(iNewIndex,LVIS_SELECTED,LVIS_SELECTED);
            ListCtrl.DeleteItem(iOffset > 0 ? iIndex : iIndex+1);
            }
        break;
        }
    while(true);
}
