// TlboxMoveableStCh.cpp : implementation file
//

#include "stdafx.h"

#include "trviewer.h"
#include "ChildFrm.h"
#include "HandleBase.h"
#include "HandleMoveable.h"
#include "EditBase.h"
#include "EditMoveable.h"

#include "ToolboxBase.h"
#include "ToolboxItfBase.h"
#include "ToolboxSheet.h"

#include "TlboxMoveableItf.h"
#include "Toolbox2Moveable.h"
#include "TlboxMoveableStCh.h"

#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "AnimMgr.h"
#include "TRAnimTrack.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CTlboxMoveableStCh property page

IMPLEMENT_DYNCREATE(CTlboxMoveableStCh, CPropertyPage)

CTlboxMoveableStCh::CTlboxMoveableStCh( CToolboxBase* lpParent ) : CToolboxItfBase(CTlboxMoveableStCh::IDD, lpParent)
{
	//{{AFX_DATA_INIT(CTlboxMoveableStCh)
	//}}AFX_DATA_INIT
	m_lAnmDispP[0] = 0;
	m_lAnmDispP[1] = 0;
	m_lAnmDispP[2] = 0;
	m_lAnmDispP[3] = 0;
	m_lAnmDispP[4] = 0;

    m_hBitmapNew        = 0;
    m_hBitmapDel        = 0;
	m_hBitmapValidate	= 0;
	m_dwCurTrack		= 0;
}

CTlboxMoveableStCh::~CTlboxMoveableStCh()
{
    if(m_hBitmapNew)        DeleteObject(m_hBitmapNew);
    if(m_hBitmapDel)        DeleteObject(m_hBitmapDel);
    if(m_hBitmapValidate)   DeleteObject(m_hBitmapValidate);

	m_ImageList.DeleteImageList();
}

void CTlboxMoveableStCh::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTlboxMoveableStCh)
	DDX_Control(pDX, IDC_ANIMDISPATCH, m_AnimDispatch);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_ANMDISP_P0, m_lAnmDispP[0]);
	DDX_Text(pDX, IDC_ANMDISP_P1, m_lAnmDispP[1]);
	DDX_Text(pDX, IDC_ANMDISP_P2, m_lAnmDispP[2]);
	DDX_Text(pDX, IDC_ANMDISP_P3, m_lAnmDispP[3]);
	DDX_Text(pDX, IDC_ANMDISP_P4, m_lAnmDispP[4]);
}


BEGIN_MESSAGE_MAP(CTlboxMoveableStCh, CPropertyPage)
	//{{AFX_MSG_MAP(CTlboxMoveableStCh)
	ON_BN_CLICKED(IDC_ANMDISP_SET, OnAnmdispSet)
	ON_NOTIFY(NM_CLICK, IDC_ANIMDISPATCH, OnClickAnimdispatch)
	ON_BN_CLICKED(IDC_ANMDISP_DEL, OnAnmDispDel)
	ON_BN_CLICKED(IDC_ANMDISP_ADD, OnAnmDispNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTlboxMoveableStCh message handlers

BOOL CTlboxMoveableStCh::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

    // Load the bitmaps
    m_hBitmapNew        = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_NEW));
    m_hBitmapDel        = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_DEL));
    m_hBitmapValidate   = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_VALIDATE));

    ::SendDlgItemMessage(m_hWnd,IDC_ANMDISP_ADD,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapNew);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMDISP_DEL,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapDel);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMDISP_SET,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapValidate);

    // Build the state changes list view
    LVCOLUMN gcoll1 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,38,__TEXT("State"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),0,&gcoll1);

    LVCOLUMN gcoll2 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,50,__TEXT("Low frm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),1,&gcoll2);

    LVCOLUMN gcoll3 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,54,__TEXT("High frm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),2,&gcoll3);

    LVCOLUMN gcoll4 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,58,__TEXT("Next anm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),3,&gcoll4);

    LVCOLUMN gcoll5 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,54,__TEXT("Next frm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),4,&gcoll5);

    m_AnimDispatch.DeleteAllItems();
    
    DWORD dwStyle1 = ListView_GetExtendedListViewStyle(m_AnimDispatch.m_hWnd);

    dwStyle1 |= LVS_EX_FULLROWSELECT;
    ListView_SetExtendedListViewStyle(m_AnimDispatch.m_hWnd, dwStyle1);

	return TRUE;
}


void CTlboxMoveableStCh::vInit( bool boNewMoveable )
{
	GET_TLBOXHANDLER( CHandleMoveable );

	DWORD	dwCurTrack = static_cast< CToolbox2Moveable* >( m_lpParent )->dwGetCurTrack();
	bool	boShowStateChanges = ( dwCurTrack != 0 )  &&  ( boNewMoveable  ||  ( !boNewMoveable  &&  dwCurTrack != m_dwCurTrack ) );

	if( dwCurTrack == 0  ||  boShowStateChanges )
		{
		m_AnimDispatch.DeleteAllItems();

		m_lAnmDispP[0] = 0;
		m_lAnmDispP[1] = 0;
		m_lAnmDispP[2] = 0;
		m_lAnmDispP[3] = 0;
		m_lAnmDispP[4] = 0;
		}

	if( boShowStateChanges )
		{
		m_dwCurTrack = dwCurTrack;

		CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

		if( lpMoveable )
			{
			CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
			CTRAnimTrack*   lpTrack = static_cast< CTRAnimTrack* >( lpAnimMgr->lpGetCurrentTrack() );
			DWORD			dwDummy;

			vShowAnimDispatch( lpTrack, 0, 0, 0, 0, 0, dwDummy );
			}
		}

    UpdateData( FALSE );
}


void CTlboxMoveableStCh::vShowAnimDispatch( CTRAnimTrack* lpTrack, DWORD dwStateId_, DWORD dwFrameLo_, DWORD dwFrameHi_, DWORD dwNextAnm_, DWORD dwNextFrm_, DWORD& dwItem )
{
    m_AnimDispatch.DeleteAllItems();

    DWORD dwIndex = 0;

    for(DWORD dwI = 0; dwI < lpTrack->dwGetNumStateChanges(); dwI++)
        {
        CString s;
        const CTRStateChange&   StateChange = lpTrack->GetStateChange(dwI);

        for(DWORD dwJ = 0; dwJ < StateChange.dwGetNumAnimDispatch(); dwJ++)
            {
            DWORD   dwTag;
            const   CTRAnimDispatch& AnimDispatch = StateChange.GetAnimDispatch(dwJ, dwTag, false);
            DWORD   dwStateId = StateChange.dwGetStateId();

            s.Format(_T("%ld"),dwStateId);

            int iItem = m_AnimDispatch.InsertItem(dwIndex++,s);

            m_AnimDispatch.SetItemData(iItem,(dwStateId << 16) + dwTag);

            DWORD dwStartFrame, dwEndFrame, dwNextAnim, dwNextFrame;

            AnimDispatch.vGetFrameRange(dwStartFrame, dwEndFrame);
            AnimDispatch.vGetNextAnim(dwNextAnim, dwNextFrame);

            if( dwStateId == dwStateId_  &&  dwFrameLo_ == dwFrameLo_  &&  dwFrameHi_ == dwFrameHi_  &&  dwNextAnm_ == dwNextAnm_  &&  dwNextFrm_ == dwNextFrm_ ) dwItem = iItem;

            s.Format(_T("%ld"),dwStartFrame + 1);   m_AnimDispatch.SetItemText(iItem,1,s);
            s.Format(_T("%ld"),dwEndFrame + 1);     m_AnimDispatch.SetItemText(iItem,2,s);
            s.Format(_T("%ld"),dwNextAnim + 1);     m_AnimDispatch.SetItemText(iItem,3,s);
            s.Format(_T("%ld"),dwNextFrame + 1);    m_AnimDispatch.SetItemText(iItem,4,s);
            }
        }
}


void CTlboxMoveableStCh::OnAnmdispSet() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = static_cast< CToolbox2Moveable* >( m_lpParent )->dwGetCurTrack(); if( dwCurAnim ) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    UpdateData(TRUE);

    DWORD   dwNewStateId = m_lAnmDispP[0];
    DWORD   dwFrameLo = m_lAnmDispP[1] - 1;
    DWORD   dwFrameHi = m_lAnmDispP[2] - 1;
    DWORD   dwNextAnm = m_lAnmDispP[3] - 1;
    DWORD   dwNextFrm = m_lAnmDispP[4] - 1;

    if( dwFrameLo > dwFrameHi )
        {
        AfxMessageBox( _T("The low frame must be less or equal to the high frame !"), MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    if( dwFrameHi >= lpTrack->dwGetNumFrames() )
        {
        CString s;
        s.Format( _T("Invalid high frame (%ld) : the animation has only %ld frames !"), dwFrameHi + 1, lpTrack->dwGetNumFrames() );
        AfxMessageBox( s, MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    if( dwNextAnm >= lpAnimMgr->dwGetNumTracks() )
        {
        CString s;
        s.Format( _T("Invalid next animation (%ld) : there are only %ld animations for this moveable !"), dwNextAnm, lpAnimMgr->dwGetNumTracks() );
        AfxMessageBox( s, MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    CTRAnimTrack*   lpTrackNext = static_cast<CTRAnimTrack*>( lpAnimMgr->lpGetTrack(dwNextAnm) );

    if( dwNextFrm >= lpTrackNext->dwGetNumFrames() )
        {
        CString s;
        s.Format( _T("Invalid next frame (%ld) : the animation %ld has only %ld frames !"), dwNextFrm + 1, dwNextAnm + 1, lpTrackNext->dwGetNumFrames() );
        AfxMessageBox( s, MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    POSITION pos = m_AnimDispatch.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimDispatch.GetNextSelectedItem(pos);

    DWORD   dwData = m_AnimDispatch.GetItemData(iItem);
    DWORD   dwStateId = dwData >> 16;
    DWORD   dwTag = dwData & 0xFFFF;

    if( dwStateId == dwNewStateId )
        {
        DWORD            dwIndex;
        CTRAnimDispatch& AnimDisp = const_cast<CTRAnimDispatch&>(lpTrack->GetStateChangeFromStateId(dwStateId).GetAnimDispatch(dwTag,dwIndex,true));

        AnimDisp.vSetFrameRange( dwFrameLo, dwFrameHi );
        AnimDisp.vSetNextAnim( dwNextAnm, dwNextFrm );

        CString s;

        s.Format(_T("%ld"),m_lAnmDispP[1]); m_AnimDispatch.SetItemText(iItem,1,s);
        s.Format(_T("%ld"),m_lAnmDispP[2]); m_AnimDispatch.SetItemText(iItem,2,s);
        s.Format(_T("%ld"),m_lAnmDispP[3]); m_AnimDispatch.SetItemText(iItem,3,s);
        s.Format(_T("%ld"),m_lAnmDispP[4]); m_AnimDispatch.SetItemText(iItem,4,s);

        UpdateData(FALSE);
        }
    else
        {
        m_AnimDispatch.DeleteItem(iItem);
        lpTrack->vRemoveAnimDispatch( dwStateId, dwTag );

        CTRStateChange  StateChange( dwNewStateId );
        CTRAnimDispatch AnimDispatch( dwFrameLo, dwFrameHi, dwNextAnm, dwNextFrm );

        StateChange.vPushAnimDispatch( AnimDispatch );

        lpTrack->vPushStateChange( StateChange );

        DWORD dwIndex = -1;

        vShowAnimDispatch( lpTrack, dwNewStateId, dwFrameLo, dwFrameHi, dwNextAnm, dwNextFrm, dwIndex );

        if( dwIndex != -1)
            {
            m_AnimDispatch.SetItemState( dwIndex, LVIS_SELECTED, LVIS_SELECTED );
            vFillAnimDispParams( dwIndex );
            }
        }
}


void CTlboxMoveableStCh::OnClickAnimdispatch(NMHDR* pNMHDR, LRESULT* pResult) 
{
	GET_TLBOXHANDLER( CHandleMoveable );

	*pResult = 0;

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = static_cast< CToolbox2Moveable* >( m_lpParent )->dwGetCurTrack(); if( dwCurAnim ) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    LPNMITEMACTIVATE lpItem = (LPNMITEMACTIVATE) pNMHDR;

    if(!lpItem  ||  lpItem->iItem == -1) return;

    vFillAnimDispParams( lpItem->iItem );
}


void CTlboxMoveableStCh::vFillAnimDispParams( int iIndex )
{
    int             iParam = 0;

    while( iParam != 5)
        {
        TCHAR   szParam[ 16 + 1 ];

        m_AnimDispatch.GetItemText( iIndex, iParam, szParam, 16 );
        m_lAnmDispP[ iParam++ ] = _ttol( szParam );
        }

    UpdateData(FALSE);
}


void CTlboxMoveableStCh::OnAnmDispDel() 
{
	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimDispatch.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int     iItem = m_AnimDispatch.GetNextSelectedItem(pos);
    DWORD   dwData = m_AnimDispatch.GetItemData(iItem);
    DWORD   dwStateId = dwData >> 16;
    DWORD   dwTag = dwData & 0xFFFF;

    m_AnimDispatch.DeleteItem(iItem);
    lpTrack->vRemoveAnimDispatch( dwStateId, dwTag );

    UpdateData( FALSE );

    if( iItem < m_AnimDispatch.GetItemCount() )
        {
        m_AnimDispatch.SetItemState( iItem, LVIS_SELECTED, LVIS_SELECTED );
        }
    else
        {
        m_AnimDispatch.SetItemState( m_AnimDispatch.GetItemCount() - 1, LVIS_SELECTED, LVIS_SELECTED );
        }
}


void CTlboxMoveableStCh::OnAnmDispNew() 
{
	GET_TLBOXHANDLER( CHandleMoveable );
 
    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if (lpTrack == NULL) return;
	
    CTRStateChange  StateChange(0);
    CTRAnimDispatch AnimDispatch( 0, 0, 0, 0 );

    StateChange.vPushAnimDispatch( AnimDispatch );

    lpTrack->vPushStateChange( StateChange );

    DWORD dwIndex;

    vShowAnimDispatch( lpTrack, 0, 0, 0, 0, 0, dwIndex );
    m_AnimDispatch.SetItemState( dwIndex, LVIS_SELECTED, LVIS_SELECTED );

    vFillAnimDispParams( dwIndex );
}


