// Toolbox2Moveable.cpp : implementation file
//

#include "stdafx.h"

#include "trviewer.h"
#include "ChildFrm.h"
#include "HandleBase.h"
#include "HandleMoveable.h"
#include "EditBase.h"
#include "EditMoveable.h"

#include "ToolboxBase.h"
#include "ToolboxItfBase.h"
#include "ToolboxSheet.h"
#include "TlboxMoveableItf.h"
#include "Toolbox2Moveable.h"

#include "TlboxMoveableMain.h"
#include "TlboxMoveableAnim.h"
#include "TlboxMoveableStCh.h"
#include "TlboxMoveableCmd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToolbox2Moveable

IMPLEMENT_DYNCREATE(CToolbox2Moveable, CToolboxBase)

CToolbox2Moveable::CToolbox2Moveable()
	: CToolboxBase(CToolbox2Moveable::IDD)
{
	//{{AFX_DATA_INIT(CToolbox2Moveable)
	//}}AFX_DATA_INIT
	m_lpMainPage = NULL;
	m_lpAnimPage = NULL;
	m_lpStateChangesPage = NULL;
	m_lpAnimCommandsPage = NULL;
}

CToolbox2Moveable::~CToolbox2Moveable()
{
}

void CToolbox2Moveable::DoDataExchange(CDataExchange* pDX)
{
	CToolboxBase::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolbox2Moveable)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolbox2Moveable, CToolboxBase)
	//{{AFX_MSG_MAP(CToolbox2Moveable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolbox2Moveable diagnostics

#ifdef _DEBUG
void CToolbox2Moveable::AssertValid() const
{
	CFormView::AssertValid();
}

void CToolbox2Moveable::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CToolbox2Moveable message handlers

void	CToolbox2Moveable::vOnInitToolbox()
{
	m_lpMainPage = new CTlboxMoveableMain( this );
	m_lpAnimPage = new CTlboxMoveableAnim( this );
	m_lpStateChangesPage = new CTlboxMoveableStCh( this );
	m_lpAnimCommandsPage = new CTlboxMoveableCmd( this );

	CPropertyPage*	lpLstPages[] =
		{
		m_lpMainPage,
		m_lpAnimPage,
		m_lpStateChangesPage,
		m_lpAnimCommandsPage
		};

	m_lpSheet->vAddPages( sizeof( lpLstPages ) / sizeof( CPropertyPage* ), lpLstPages );
}


void	CToolbox2Moveable::vCheckKeys()
{
	bool			boReinit		= false;
	CPropertyPage*  pVisiblePage	= m_lpSheet->lpGetVisiblePage();

	boReinit |= m_lpAnimPage->boCheckKeys()  &&  (pVisiblePage != static_cast<CPropertyPage*>(m_lpAnimPage));

	if (boReinit)
		static_cast<CToolboxItfBase*>(pVisiblePage)->vInit(false);
}


//
//
// ITlboxMeshItfMain
//
//

void    CToolbox2Moveable::vRefreshExtents( bool boUpdateData /*= true*/ )
{
	static_cast< CTlboxMoveableMain* >( m_lpMainPage )->vRefreshExtents( boUpdateData );
}



//
//
// ITlboxMoveableItfAnim
//
//

void    CToolbox2Moveable::vSetCurAnim( DWORD dwCurAnim )
{
	static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->vSetCurAnim( dwCurAnim );
}


void    CToolbox2Moveable::vSetCurFrame( DWORD dwCurFrame, DWORD dwNumFrames )
{
	static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->vSetCurFrame( dwCurFrame, dwNumFrames );
}


void    CToolbox2Moveable::vSetCurKey( DWORD dwCurKey, DWORD dwNumKeys )
{
	static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->vSetCurKey( dwCurKey, dwNumKeys );
}


void    CToolbox2Moveable::vSetAnimationFrameRate( DWORD dwAnimFrameRate )
{
	static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->vSetAnimationFrameRate( dwAnimFrameRate );
}


void    CToolbox2Moveable::vSetAnimationNextAnim( DWORD dwNextAnim, DWORD dwNextFrame )
{
	static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->vSetAnimationNextAnim( dwNextAnim, dwNextFrame );
}


void    CToolbox2Moveable::vSetInterp( float fInterp )
{
	static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->vSetInterp( fInterp );
}


bool    CToolbox2Moveable::boIsAnimModeAutomatic()
{
	return static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->boIsAnimModeAutomatic();
}


DWORD   CToolbox2Moveable::dwGetCurTrack()
{
	return static_cast< CTlboxMoveableAnim* >( m_lpAnimPage )->dwGetCurTrack();
}
