#include "stdafx.h"

#include "Resource.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "HandleBase.h"

#include "ToolboxBase.h"
#include "ToolboxSheet.h"

extern bool g_boFixToolbox;

IMPLEMENT_DYNCREATE(CToolboxBase, CFormView)


CToolboxBase::CToolboxBase() :
	CFormView( IDD_TOOLBOX_EMPTY ), 
	m_lpDataHandler( NULL ), m_lpDataEdit( NULL ), m_lpSheet( NULL )
{
}


CToolboxBase::~CToolboxBase()
{
	delete m_lpSheet;
	
	m_lpSheet = NULL;
}


void CToolboxBase::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolboxBase)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolboxBase, CFormView)
	//{{AFX_MSG_MAP(CToolboxBase)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void	CToolboxBase::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	m_lpSheet = new CToolboxSheet(this); 

	vOnInitToolbox();

	if( !m_lpSheet->Create(this, WS_CHILD | WS_VISIBLE, 0) )
		{ 
		delete m_lpSheet;

		m_lpSheet = NULL; 

		return; 
		} 

	m_lpSheet->Resize();
}


void	CToolboxBase::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	if( m_lpSheet ) m_lpSheet->Resize();
}


bool	CToolboxBase::vSetHandlers( CHandleBase* lpHandler, CEditBase* lpEdit )
{
	bool bo = ((CMainFrame*)(AfxGetApp()->m_pMainWnd))->boGetToolboxVisibility();

	if (bo && g_boFixToolbox)
	{
		((CMainFrame*)(AfxGetApp()->m_pMainWnd))->vSetToolboxType(false);
		return false;
	}

	CHandleBase* lpOldHandler = m_lpDataHandler;

	m_lpDataHandler = lpHandler;
	m_lpDataEdit	= lpEdit;

	CPropertyPage* lpActivePage = m_lpSheet->GetActivePage();

    bool	boNewObject = true;
    void*	lpObject = m_lpDataHandler ? m_lpDataHandler->lpGetData() : NULL;

    if( lpOldHandler )
        {
        void*   lpOldObject = lpOldHandler->lpGetData();

        boNewObject = ( lpObject != lpOldObject );
        }

	m_lpSheet->vInitPages( boNewObject );

	m_lpSheet->SetActivePage( lpActivePage );

	return true;
}


void	CToolboxBase::vOnActivatePage( CToolboxItfBase* lpPage )
{
	m_lpSheet->vInitActivatedPage( lpPage );
}
