#pragma once


class CTrSndMgr
{
public:

    CTrSndMgr() : m_SoundMap() { }
    CTrSndMgr(CTRFile* lpTRFile);
    CTrSndMgr(BYTE* lpbData);

    ~CTrSndMgr();

    DWORD   dwGetDataSize();
    BYTE*   lpbGetData(DWORD& dwDataSize);

    bool    boHaveSound(DWORD dwInternalIndex);
    bool    boAddSound(DWORD dwInternalIndex, TR2_SOUND_DETAILS* lpSoundDetail, DWORD dwFirstSoundIndex);
    bool    boCopySound(CTrSndMgr* lpSndMgrSrc, DWORD dwInternalIndex);
    void    vRemoveSound(DWORD dwInternalIndex);

    void    vMerge(CTrSndMgr* lpSndMgr,bool boDelete = false);
    void    vConvertToTR(CTRFile* lpTRFile);

private:

    class CTrSnd
    {
    public:

        CTrSnd(CTrSnd* lpSnd);
        CTrSnd(TR2_SOUND_DETAILS* lpSoundDetail, DWORD dwFirstSoundIndex,DWORD dwInternalIndex);
        CTrSnd(BYTE* lpbData,DWORD dwInternalIndex);

        static DWORD    dwGetDataSize();
        void            vSerialize(BYTE* lpbData);

        void            vConvertToTR(TR2_SOUND_DETAILS* lpSoundDetail, DWORD dwSampleIndice);

        DWORD           dwGetNumSounds() const			{ return m_wNumSounds; }
        DWORD           dwGetFirstSoundIndex() const	{ return m_dwFirstSoundIndex; }
		short			sGetSample() const				{ return m_sSample; }

        void            vSetOtherSoundIndex(DWORD dwIndex) { m_dwOtherSoundIndex.push_back(dwIndex); }
        DWORD           dwGetOtherSoundIndex(DWORD dwNum) { return dwNum < m_dwOtherSoundIndex.size() ? m_dwOtherSoundIndex[dwNum] : m_dwFirstSoundIndex + dwNum; }

    private:

        DWORD   m_dwInternalIndex;
        DWORD   m_dwFirstSoundIndex;
        WORD    m_wNumSounds;
        long    m_lVolume;
        short   m_sUnknown1;
        short   m_sUnknown2;
		short	m_sSample;
        std::vector<DWORD> m_dwOtherSoundIndex;

        friend class CTrSndMgr;
        friend class CEditSounds;
    };

    bool    boAddSound(CTrSndMgr::CTrSnd* lpSnd);

    typedef std::map<DWORD, CTrSnd*> MapIdx2Snd;

    MapIdx2Snd      m_SoundMap;

    friend class CEditSounds;
};
